gtkmm: Gtk::SliceListModel Class Reference

gtkmm 4.0.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::SliceListModel Class Reference

A list model that presents a slice out of a larger list. More...

`#include <gtkmm/slicelistmodel.h>`

Inheritance diagram for Gtk::SliceListModel:
[legend]

## Public Member Functions
| SliceListModel (SliceListModel&& src) noexcept
SliceListModel& | operator= (SliceListModel&& src) noexcept
| ~SliceListModel () noexcept override
GtkSliceListModel* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSliceListModel* | gobj () const
| Provides access to the underlying C GObject. More...
GtkSliceListModel* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_model (const Glib::RefPtr< Gio::ListModel >& model)
| Sets the model to show a slice of. More...
Glib::RefPtr< Gio::ListModel > | get_model ()
| Gets the model that is currently being used or `nullptr` if none. More...
Glib::RefPtr< const Gio::ListModel > | get_model () const
| Gets the model that is currently being used or `nullptr` if none. More...
void | set_offset (guint offset)
| Sets the offset into the original model for this slice. More...
guint | get_offset () const
| Gets the offset set via set_offset() More...
void | set_size (guint size)
| Sets the maximum size. More...
guint | get_size () const
| Gets the size set via set_size(). More...
Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > | property_model ()
| Child model to take slice from. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_model () const
| Child model to take slice from. More...
Glib::PropertyProxy< guint > | property_offset ()
| Offset of slice. More...
Glib::PropertyProxy_ReadOnly< guint > | property_offset () const
| Offset of slice. More...
Glib::PropertyProxy< guint > | property_size ()
| Maximum size of slice. More...
Glib::PropertyProxy_ReadOnly< guint > | property_size () const
| Maximum size of slice. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SliceListModel > | create (const Glib::RefPtr< Gio::ListModel >& model, guint offset, guint size)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| SliceListModel (const Glib::RefPtr< Gio::ListModel >& model, guint offset, guint size)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::SliceListModel > | wrap (GtkSliceListModel* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model that presents a slice out of a larger list.

Gtk::SliceListModel is a list model that takes a list model and presents a slice of that model.

This is useful when implementing paging by setting the size to the number of elements per page and updating the offset whenever a different page is opened.

See also
  Gio::ListModel

Since gtkmm 3.98:

## Constructor & Destructor Documentation

Gtk::SliceListModel::SliceListModel | ( | SliceListModel&& | src | ) |
| noexcept

Gtk::SliceListModel::~SliceListModel | ( |  | ) |
| overridenoexcept

Gtk::SliceListModel::SliceListModel | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | guint | offset,
|  | guint | size
| ) |  |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<SliceListModel> Gtk::SliceListModel::create | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | guint | offset,
|  | guint | size
| ) |  |
| static

Glib::RefPtr<Gio::ListModel> Gtk::SliceListModel::get_model | ( |  | ) |

Gets the model that is currently being used or `nullptr` if none.

Returns
  The model in use.

Glib::RefPtr<const Gio::ListModel> Gtk::SliceListModel::get_model | ( |  | ) | const

Gets the model that is currently being used or `nullptr` if none.

Returns
  The model in use.

guint Gtk::SliceListModel::get_offset | ( |  | ) | const

Gets the offset set via set_offset()

Returns
  The offset.

guint Gtk::SliceListModel::get_size | ( |  | ) | const

Gets the size set via set_size().

Returns
  The size.

static GType Gtk::SliceListModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkSliceListModel* Gtk::SliceListModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkSliceListModel* Gtk::SliceListModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkSliceListModel* Gtk::SliceListModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

SliceListModel& Gtk::SliceListModel::operator= | ( | SliceListModel&& | src | ) |
| noexcept

Glib::PropertyProxy< Glib::RefPtr<Gio::ListModel> > Gtk::SliceListModel::property_model | ( |  | ) |

Child model to take slice from.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::ListModel> > Gtk::SliceListModel::property_model | ( |  | ) | const

Child model to take slice from.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< guint > Gtk::SliceListModel::property_offset | ( |  | ) |

Offset of slice.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint > Gtk::SliceListModel::property_offset | ( |  | ) | const

Offset of slice.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< guint > Gtk::SliceListModel::property_size | ( |  | ) |

Maximum size of slice.

Default value: 10

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint > Gtk::SliceListModel::property_size | ( |  | ) | const

Maximum size of slice.

Default value: 10

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::SliceListModel::set_model | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |

Sets the model to show a slice of.

The model's item type must conform to self's item type.

Parameters

  model | The model to be sliced.

void Gtk::SliceListModel::set_offset | ( | guint | offset | ) |

Sets the offset into the original model for this slice.

If the offset is too large for the sliced model, self will end up empty.

Parameters

  offset | The new offset to use.

void Gtk::SliceListModel::set_size | ( | guint | size | ) |

Sets the maximum size.

self will never have more items than size.

It can however have fewer items if the offset is too large or the model sliced from doesn't have enough items.

Parameters

  size | The maximum size.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::SliceListModel > wrap | ( | GtkSliceListModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.